
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CoursesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const courses = await db.courses.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        slug: data.slug
        ||
        null
            ,
            
        level: data.level
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        tags: data.tags
        ||
        null
            ,
            
        estimated_hours: data.estimated_hours
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await courses.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await courses.setAuthor( data.author || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.courses.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: courses.id,
            },
            data.cover_image,
            options,
        );
        

        return courses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const coursesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                slug: item.slug
            ||
            null
            ,
            
                level: item.level
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                tags: item.tags
            ||
            null
            ,
            
                estimated_hours: item.estimated_hours
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const courses = await db.courses.bulkCreate(coursesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < courses.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.courses.getTableName(),
                    belongsToColumn: 'cover_image',
                    belongsToId: courses[i].id,
                },
                data[i].cover_image,
                options,
            );
        }
        

        return courses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const courses = await db.courses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.slug !== undefined) updatePayload.slug = data.slug;
        
        
        if (data.level !== undefined) updatePayload.level = data.level;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.tags !== undefined) updatePayload.tags = data.tags;
        
        
        if (data.estimated_hours !== undefined) updatePayload.estimated_hours = data.estimated_hours;
        
        
        updatePayload.updatedById = currentUser.id;

        await courses.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await courses.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await courses.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.courses.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: courses.id,
            },
            data.cover_image,
            options,
        );
        

        return courses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const courses = await db.courses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of courses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of courses) {
                await record.destroy({transaction});
            }
        });


        return courses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const courses = await db.courses.findByPk(id, options);

        await courses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await courses.destroy({
            transaction
        });

        return courses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const courses = await db.courses.findOne(
            { where },
            { transaction },
        );

        if (!courses) {
            return courses;
        }

        const output = courses.get({plain: true});

        
        
        
        
        
        
        output.lessons_course = await courses.getLessons_course({
            transaction
        });
        
        
        
        
        
        
        
        output.enrollments_course = await courses.getEnrollments_course({
            transaction
        });
        
        
        output.progress_records_course = await courses.getProgress_records_course({
            transaction
        });
        
        
        
        output.leaderboards_course = await courses.getLeaderboards_course({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.comments_course = await courses.getComments_course({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.cover_image = await courses.getCover_image({
            transaction
        });
        
        
        output.organization = await courses.getOrganization({
            transaction
        });
        
        
        output.author = await courses.getAuthor({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'cover_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'courses',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.slug) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'courses',
                        'slug',
                        filter.slug,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'courses',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'courses',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.tags) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'courses',
                        'tags',
                        filter.tags,
                    ),
                };
            }
            

            
            

            
            if (filter.estimated_hoursRange) {
                const [start, end] = filter.estimated_hoursRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    estimated_hours: {
                    ...where.estimated_hours,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    estimated_hours: {
                    ...where.estimated_hours,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.level) {
                where = {
                    ...where,
                level: filter.level,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.courses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'courses',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.courses.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

